SoAntiSquish(3)

NAME
SoAntiSquish - The SoAntiSquish class is used to reset to uniform scaling.

SYNOPSIS

#include <Inventor/nodes/SoAntiSquish.h>

Inherits SoTransformation.

  Public Types
enum Sizing { X, Y, Z, AVERAGE_DIMENSION, BIGGEST_DIMENSION, SMALLEST_DIMENSION, LONGEST_DIAGONAL }

  Public Member Functions
virtual SoType getTypeId (void) const
SoAntiSquish (void)
void recalc (void)
virtual void doAction (SoAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFEnum sizing
SoSFBool recalcAlways

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoAntiSquish ()
virtual void callback (SoCallbackAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
virtual void getMatrix (SoGetMatrixAction *action)
virtual void pick (SoPickAction *action)
SbMatrix getUnsquishingMatrix (const SbMatrix &squishedmatrix, const SbBool calcinverse, SbMatrix &getinverse)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoAntiSquish class is used to reset to uniform scaling. When traversed, this node replaces the scale vector of the matrix with uniform values, based on one of the SoAntiSquish::Sizing strategies.

This node is for instance used by manipulators to retain the shape of their dragger geometries when set up within the influence of an SoSurroundScale node (which can yield nonuniform scale-vectors in the current state transformation matrix).

FILE FORMAT/DEFAULTS:

AntiSquish {
    recalcAlways TRUE
    sizing AVERAGE_DIMENSION
}

See also
    SoSurroundScale for a usage example.

Member Enumeration Documentation

  enum SoAntiSquish::Sizing
Different strategies for 'unsquishing' a nonuniform scaling. Values are used by the SoAntiSquish::sizing field.

Enumerator

X   The X-axis scaling factor is used.

Y   The Y-axis scaling factor is used.

Z   The Z-axis scaling factor is used.

AVERAGE_DIMENSION
    The average value of the scaling factors is used.

BIGGEST_DIMENSION
    The biggest of all scaling factors is used.

SMALLEST_DIMENSION
    The smallest of all scaling factors is used.

LONGEST_DIAGONAL
    A unit cube is transformed by the current state transformation matrix. The scaling factor is set to the value of its longest diagonal.

Constructor & Destructor Documentation

  SoAntiSquish::SoAntiSquish (void)
Constructor.

  SoAntiSquish::~SoAntiSquish () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoAntiSquish::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoAntiSquish::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoTransformation.

  const SoFieldData ** SoAntiSquish::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoAntiSquish::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoTransformation.

  void SoAntiSquish::recalc (void)
If SoAntiSquish::recalcAlways has been set to FALSE, you must call this method whenever the transformations before this node in the graph has changed.

See also
    SoAntiSquish::recalcAlways

  void SoAntiSquish::doAction (SoAction * action) [virtual]
Accumulates an 'unsquishing' matrix on top of the current model matrix.

Reimplemented from SoNode.

  void SoAntiSquish::callback (SoCallbackAction * action) [protected], [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

  void SoAntiSquish::GLRender (SoGLRenderAction * action) [protected], [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoAntiSquish::getBoundingBox (SoGetBoundingBoxAction * action) [protected], [virtual]
Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoNode.

  void SoAntiSquish::getMatrix (SoGetMatrixAction * action) [protected], [virtual]
Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

  void SoAntiSquish::pick (SoPickAction * action) [protected], [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

  SbMatrix SoAntiSquish::getUnsquishingMatrix (const SbMatrix & squishedmatrix, const SbBool calcinverse, SbMatrix & getinverse) [protected]
Calculate and return the matrix needed to 'unsquish' the squishedmatrix.

If calcinverse is TRUE, store the inverse of the unsquishmatrix in getinverse.

Member Data Documentation

  SoSFEnum SoAntiSquish::sizing
The current 'unsquish' strategy. Default value is SoAntiSquish::AVERAGE_DIMENSION.

  SoSFBool SoAntiSquish::recalcAlways
Whether to automatically have the unsquishing parameters recalculated for every traversal. Default value is TRUE.

You can set this to FALSE and manually invoke SoAntiSquish::recalc() if you need closer control of the geometry influenced by this node.

Author

Generated automatically by Doxygen for Coin from the source code.